"use strict";
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _FacadeTransport_url;
Object.defineProperty(exports, "__esModule", { value: true });
exports.FacadeTransport = void 0;
const nanoid_1 = require("nanoid");
const sdk_core_1 = require("@race-foundation/sdk-core");
const borsh_1 = require("@race-foundation/borsh");
class FacadeTransport {
    constructor(url = 'http://localhost:12002') {
        _FacadeTransport_url.set(this, void 0);
        __classPrivateFieldSet(this, _FacadeTransport_url, url, "f");
    }
    createGameAccount(wallet, params) {
        throw new Error('Method not implemented.');
    }
    closeGameAccount(wallet, params) {
        throw new Error('Method not implemented.');
    }
    deposit(wallet, params) {
        throw new Error('Method not implemented.');
    }
    vote(wallet, params) {
        throw new Error('Method not implemented.');
    }
    publishGame(wallet, params) {
        throw new Error('Method not implemented.');
    }
    createRegistration(wallet, params) {
        throw new Error('Method not implemented.');
    }
    registerGame(wallet, params) {
        throw new Error('Method not implemented.');
    }
    unregisterGame(wallet, params) {
        throw new Error('Method not implemented.');
    }
    async createPlayerProfile(wallet, params) {
        const playerAddr = wallet.walletAddr;
        const ix = { playerAddr, ...params };
        await this.sendInstruction('create_profile', ix);
    }
    async join(wallet, params) {
        const playerAddr = wallet.walletAddr;
        const ix = { playerAddr, ...params };
        await this.sendInstruction('join', ix);
    }
    async getGameAccount(addr) {
        const data = await this.fetchState('get_account_info', addr);
        if (data === undefined)
            return undefined;
        return (0, borsh_1.deserialize)(sdk_core_1.GameAccount, data);
    }
    async getGameBundle(addr) {
        const data = await this.fetchState('get_game_bundle', addr);
        if (data === undefined)
            return undefined;
        return (0, borsh_1.deserialize)(sdk_core_1.GameBundle, data);
    }
    async getPlayerProfile(addr) {
        const data = await this.fetchState('get_profile', addr);
        if (data === undefined)
            return undefined;
        return (0, borsh_1.deserialize)(sdk_core_1.PlayerProfile, data);
    }
    async getServerAccount(addr) {
        const data = await this.fetchState('get_server_info', addr);
        if (data === undefined)
            return undefined;
        return (0, borsh_1.deserialize)(sdk_core_1.ServerAccount, data);
    }
    async getRegistration(addr) {
        const data = await this.fetchState('get_registration_info', addr);
        if (data === undefined)
            return undefined;
        return (0, borsh_1.deserialize)(sdk_core_1.RegistrationAccount, data);
    }
    async getToken(addr) {
        return {
            addr,
            icon: '',
            name: 'Fake Token',
            symbol: 'FT',
            decimals: 0,
        };
    }
    async getNft(_addr) {
        return undefined;
    }
    async sendInstruction(method, ix) {
        const reqData = JSON.stringify({
            jsonrpc: '2.0',
            method,
            id: (0, nanoid_1.nanoid)(),
            params: [ix],
        }, (_key, value) => (typeof value === 'bigint' ? Number(value) : value));
        const resp = await fetch(__classPrivateFieldGet(this, _FacadeTransport_url, "f"), {
            method: 'POST',
            body: reqData,
            headers: {
                'Content-Type': 'application/json',
            },
        });
        if (!resp.ok) {
            throw new Error('Failed to send instruction: ' + reqData);
        }
    }
    async fetchState(method, addr) {
        const reqData = JSON.stringify({
            jsonrpc: '2.0',
            method,
            id: (0, nanoid_1.nanoid)(),
            params: [addr],
        });
        const resp = await fetch(__classPrivateFieldGet(this, _FacadeTransport_url, "f"), {
            method: 'POST',
            body: reqData,
            headers: {
                'Content-Type': 'application/json',
            },
        });
        if (!resp.ok) {
            throw new Error('Failed to fetch data at :' + addr);
        }
        const { result } = await resp.json();
        if (result !== null) {
            return Uint8Array.from(result);
        }
        else {
            return undefined;
        }
    }
}
exports.FacadeTransport = FacadeTransport;
_FacadeTransport_url = new WeakMap();
//# sourceMappingURL=facade-transport.js.map